#ifndef CONTROLLER_SEGMENT_H
#define CONTROLLER_SEGMENT_H

#include <cstdint>
#include <chrono>
#include <string>
#include <vector>

struct controller_segment
{
    controller_segment();
    void init();
    void reset();
    enum block_transfer_state
    {
        bts_inactive,
        bts_active
    };
    enum block_transfer_type
    {
        btt_none                 = 0x00000000,
        btt_list                 = 0x00000001,
        btt_access_control_list  = 0x00000002,
        btt_write_file           = 0x00000004,
        btt_read_file            = 0x00000008,
        btt_write_setup_file     = 0x00000010,
        btt_read_setup_file      = 0x00000020,
        btt_mask_known           = 0x0000003F
    };
    enum controller_flag
    {
        cf_settings_from_global         = 0x00000001
    };

    block_transfer_state transfer_state;
    block_transfer_type transfer_type;
    uint32_t transfer_flags;
    uint32_t allowed_transfer_types;
    std::chrono::system_clock::duration duration;
    std::chrono::system_clock::time_point begin_time_point;
    std::chrono::system_clock::time_point current_time_slot_time_point;
    std::chrono::system_clock::time_point end_time_point;
    uint16_t update_variation;
    uint32_t number;
    uint32_t max_number;
    uint32_t address;
    uint32_t size;
    uint32_t crc;
    bool resume;
    bool discard;
    std::string file_path;
    std::vector<uint8_t> file_data;
};

#endif
